<?php
namespace Incoviba\Repository\Venta\Abono;

use Incoviba\Common\Ideal;
use Incoviba\Common\Define;
use Incoviba\Common\Implement;
use Incoviba\Common\Implement\Exception\EmptyResult;
use Incoviba\Model;
use Incoviba\Repository;
use Incoviba\Service;

class Cuota extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Repository\Venta $ventaRepository,
                                protected Service\Venta\Pago $pagoService)
    {
        parent::__construct($connection);
        $this->setTable('venta_abono_cuotas');
    }

    public function create(?array $data = null): Model\Venta\Abono\Cuota
    {
        $map = (new Implement\Repository\MapperParser(['numero']))
            ->register('venta_id', (new Implement\Repository\Mapper())
                ->setProperty('venta')
                ->setFunction(function($data) {
                    return $this->ventaRepository->fetchById($data['venta_id']);
                })
            )
            ->register('pago_id', (new Implement\Repository\Mapper())
                ->setProperty('pago')
                ->setFunction(function($data) {
                    return $this->pagoService->getById($data['pago_id']);
                })
            );
        return $this->parseData(new Model\Venta\Abono\Cuota(), $data, $map);
    }

    public function save(Define\Model $model): Model\Venta\Abono\Cuota
    {
        $model->id = $this->saveNew(['venta_id', 'pago_id', 'numero'], [$model->venta->id, $model->pago->id, $model->numero]);
        return $model;
    }

    public function edit(Define\Model $model, array $new_data): Model\Venta\Abono\Cuota
    {
        return $this->update($model, ['venta_id', 'pago_id', 'numero'], $new_data);
    }

    /**
     * @throws EmptyResult
     */
    public function fetchByVenta(int $venta_id): array
    {
        $query = $this->connection->getQueryBuilder()
            ->select()
            ->from($this->getTable())
            ->where('venta_id = ?');
        return $this->fetchMany($query, [$venta_id]);
    }
}
